<?PHP

session_start();

include_once('conf/config.php');
include_once('conf/ELOconfig.php');
include_once('lib/utils.php');

CheckSession();

include_once('lib/dbwrapper.php');
include_once('lib/chessdb.php');

############################################################
function inviteHandle(){
############################################################
    switch($_POST['ToDo']){
    case 'InvitePlayer':
	/* prevent multiple pending requests between two players with the same originator */
        $whereStr  = "gameMessage = 'playerInvited'";
	$whereStr .= " AND ((messageFrom = 'white' AND whitePlayer = ".$_SESSION['playerID']." AND blackPlayer = ".$_POST['opponent'].")";
	$whereStr .= " OR (messageFrom = 'black' AND whitePlayer = ".$_POST['opponent']." AND blackPlayer = ".$_SESSION['playerID']."))";
	$tmpExistingRequests =  SelGames("gameID",$whereStr);

	if (GetNumRows($tmpExistingRequests) == 0){
	    if ($_POST['color'] == 'random'){
		mt_srand((double)microtime() * 1000000);
		$tmpColor = (mt_rand(0,1) == 1) ? "white" : "black";
	    }else
		$tmpColor = $_POST['color'];
	    
	    if ($tmpColor == 'white')
		$insStr = "('',".$_SESSION['playerID'].", ".$_POST['opponent']."";
	    else
		$insStr = "('',".$_POST['opponent'].", ".$_SESSION['playerID']."";

	    $insStr .= ", 'playerInvited', '".$tmpColor."', NOW(), NOW(),0,0)";
	    InsGames($insStr);

	    /* if email notification is activated... */
	    if ($GLOBALS[CFG_USEEMAILNOTIFICATION]){
		$tmpMail = getUserMail($_POST['opponent']);
		if($tmpMail['mailnotify'] == 1)
		    webchessMail('invitation', $tmpMail['email'], '', $_SESSION['nick']);
	    }
	    //write log
	    $logmess = "Invited UID: ".$_POST['opponent']." color: ".$_POST['color'];
	    writeLog(EVENT,$logmess);
	}
	break;
    }
}

############################################################
function genELOListing(){
############################################################
    $elorate	= array();
    $elochange 	= array();
    $nick	= array();
    $activgames = array();
    $abortgames = array();
    $gamescount = array();
    $dbgames	= array();
    $invited	= array();
    $mygame	= array();
    $tmpPlayers = SelUser("*","user_group_id <> 1 AND active = 1");
    while($thisPlayer = GetFetchArray($tmpPlayers)){
	$wheStr = "user_id = ".$thisPlayer['id']."";
	$ordStr = "id DESC";
	$tmpElorating = SelStatistic("*",$wheStr,$ordStr);
  	$gamescount[$thisPlayer['id']] = GetNumRows($tmpElorating);
  	if ($gamescount[$thisPlayer['id']] > 0){
  	    $firstline = 0;
  	    $abortgames[$thisPlayer['id']] = 0;
	    $countlines = 0;
  	    while($thisElorating = GetFetchArray($tmpElorating)){
  		if($firstline == 0)	{
  		    $elorate[$thisPlayer['id']]	 = $thisElorating['elo_rate'];
		    $elochange[$thisPlayer['id']] = $thisElorating['elo_change'];
  		    $firstline = 1;
  		}
  		$abortgames[$thisPlayer['id']] += $thisElorating['game_abort'];
		$countlines += 1;
		if($countlines >= $GLOBALS[CFG_ELO_RELIAB_LINES])
		    break;
  	    }
  	}else{
    	    $elorate[$thisPlayer['id']] = 0;
    	}
    	$nick[$thisPlayer['id']]	= $thisPlayer['login_name'];

        // get all active games
        $row = 0;
	$wheStr  = "( whitePlayer = ".$thisPlayer['id']." ";
	$wheStr .= "OR blackPlayer = ".$thisPlayer['id']." ) ";
	$wheStr .= "AND gameMessage <> 'inviteDeclined'";
	$tmpGames = SelGames("*",$wheStr);
	$activgames[$thisPlayer['id']] 	= 0;
	$dbgames[$thisPlayer['id']]	= 0;	
	while($tmpGame = GetFetchArray($tmpGames)){
	    if($tmpGame['gameMessage'] == ''){
	 	$activgames[$thisPlayer['id']] 	+= 1;
		if($tmpGame['whitePlayer'] == $_SESSION['playerID'] || $tmpGame['blackPlayer'] == $_SESSION['playerID'])
		    $mygame[$thisPlayer['id']]	+= 1;
	    }
	    if($tmpGame['whitePlayer'] == $_SESSION['playerID'] || $tmpGame['blackPlayer'] == $_SESSION['playerID']){
		if($tmpGame['gameMessage'] == 'playerInvited')
		    $invited[$thisPlayer['id']]	= 1;
	    }
	    if($tmpGame['gameMessage'] != 'playerInvited')
	    	$dbgames[$thisPlayer['id']]	+= 1;		
	}
    }
    arsort($elorate);

    echo("<form name='invite' action='elorate.php' method='post'>\n");
    echo("<input type='hidden' name='ToDo' value='InvitePlayer'>\n");
    echo("<input type='hidden' name='color' value=''>\n");
    echo("<input type='hidden' name='opponent' value=''>\n");
    echo "<table class ='tabbord1' width='80%'>\n";
    echo " <tr><th class='th_std' colspan='8'>".$_SESSION['TXT']['EloRanking']."</th></tr>\n";
    echo " <tr>\n";
    echo "  <th class='th_std'></th>\n";
    echo "  <th class='th_std'>".$_SESSION['TXT']['BtnInvite']."</th>\n";
    echo "  <th class='th_std'></th>\n";	
    echo "  <th class='th_std'>".$_SESSION['TXT']['Name']."</th>\n";
    echo "  <th class='th_std'>".$_SESSION['TXT']['EloPoints']."</th>\n";
    echo "  <th class='th_std'>".$_SESSION['TXT']['EloChange']."</th>\n";	
    echo "  <th class='th_std'>".$_SESSION['TXT']['Reliability']."</th>\n";
    echo "  <th class='th_std'>".$_SESSION['TXT']['ActiveGames']."</th>\n";
    echo "</tr>\n";
    $tmpcount = 1;
    for($x=0;$x<sizeof($elorate);$x++) {
        $pID    = key($elorate);
        $elor   = current($elorate);
        $nic    = $nick[$pID];
        $actg	= $activgames[$pID];
	$elch	= $elochange[$pID];
	$dbg	= $dbgames[$pID];
	$inv	= $invited[$pID];
	$gam	= $mygame[$pID];
	next($elorate);
	// display only active player
	if($dbg == 0 && $elor != 0 && $_SESSION['playerID'] != $pID && $GLOBALS[CFG_ELO_SHOW_ACTIVE_ONLY] == 1 )
	    continue;

        if($abortgames[$pID] == 0)
    	    $reli = 100;
        else{
	    if($GLOBALS[CFG_ELO_RELIAB_LINES] >= $gamescount[$pID])
		$gamecnt = $gamescount[$pID] - 1;
	    else
		$gamecnt = $GLOBALS[CFG_ELO_RELIAB_LINES];

	    $goodgames = $gamecnt - $abortgames[$pID];
            if($goodgames == 0)
        	$reli	= 0;
            else
        	$reli	= round($goodgames/$gamecnt*100);
    	}

    	if($_SESSION['playerID'] == $pID){
    	    echo("<tr class='tr_usr'>\n");
	    echo("<td>".$tmpcount."</td>");
    	    echo("<td></td>\n");
    	}else{
	    if($tmpcount%2)
            	echo("<tr class='tr_std'>\n");
	    else
	    	echo("<tr class='tr_std_l'>\n");
	    echo("<td>".$tmpcount."</td>");
	    echo("<td>");
	    if(!$inv){
	    	echo "<img class='activIcon' src='template/".$_SESSION['pref_theme']."/images/white.gif' width='14' height='14' title='".$_SESSION['TXT']['TTInviteWhite']."' alt='W' onClick='inv(".$pID.",\"white\");'>\n";
	    	echo "<img class='activIcon' src='template/".$_SESSION['pref_theme']."/images/black.gif' width='14' height='14' title='".$_SESSION['TXT']['TTInviteBlack']."' alt='B' onClick='inv(".$pID.",\"black\");'>\n";
	    	echo "<img class='activIcon' src='template/".$_SESSION['pref_theme']."/images/wb_inv.gif' width='14' height='14' title='".$_SESSION['TXT']['TTInviteRandom']."' alt='R' onClick='inv(".$pID.",\"random\");'>\n";
	    }
	    echo("</td>\n");

    	}
	echo("<td>");
	if($gam && $_SESSION['playerID'] != $pID){
	    echo "<img src='template/".$_SESSION['pref_theme']."/images/chessclock.gif' width='24' height='15' border='0' title='".$_SESSION['TXT']['TTChessClock']."' alt='C'>\n";
	}
	echo("</td>\n");

	dispUserInfoLink($pID, $nic);

    	if($elor == 0)
 	    echo("<td width='100px' >".$_SESSION['TXT']['NotRated']."</td>");
    	else
            echo("<td width='100px' >".$elor."</td>");

	if($elch > 0)
	    echo("<td class='td_rightG' width='40px' > +".$elch."</td>");
	else if($elch == 0)
	    echo("<td class='td_right' width='40px' ></td>");
	else
	    echo("<td class='td_rightR' width='40px' > ".$elch."</td>");
	echo("<td>".$reli."%</td>");
    	echo("<td>".$actg."</td>");
    	echo("</tr>\n");
	$tmpcount ++;
    }
    echo "</table>\n";
    echo("</form>\n");
    echo "<br>\n";
}

############################################################
function dispEloChangeWarning() {
############################################################
    if ( $GLOBALS[CFG_ELO_OLD_START_RATE] != -1 ){
	if ( $GLOBALS[CFG_ELO_OLD_START_RATE] != $GLOBALS[CFG_ELO_START_RATE] ){
	$infostr1  = $_SESSION['TXT']['EloChangeWarn1'];
    	$infostr1 .= $_SESSION['TXT']['EloChangeWarn2']; 
	    echo "<table class ='tabbord1' width='80%'>\n";
    	    echo " <tr><th class='th_std'>".$_SESSION['TXT']['EloChangeWarn']."</th></tr>\n";
            echo " <tr class='tr_std'>\n";
            echo "  <td>".$infostr1."</td>\n";
            echo " </tr>\n";
            echo "</table>\n";
            echo "<br>\n";
      	}
    }
}

############################################################
function dispJSEloPage() {
############################################################
    echo "<script type='text/javascript'>\n";
    echo " function inv(userID,color){\n";
    echo "  document.invite.opponent.value = userID;\n";
    echo "  document.invite.color.value = color;\n";
    echo "  document.invite.submit();\n";
    echo " }\n";
    echo "</script>\n";
}

############################################################
function dispEloPage() {
############################################################
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html><head>\n";
    echo "<meta http-equiv='content-type' content='text/html; charset=UTF-8'>\n";
    echo " <title>WebChessNG - ".$_SESSION['TXT']['TitleStatistic']."</title>\n";
    echo " <link rel='stylesheet' type='text/css' href='template/".$_SESSION['pref_theme']."/webchess.css'>\n";
    dispJSEloPage();
    echo "</head><body><br>\n";
    echo " <center>\n";
    $pagetitel = $_SESSION['TXT']['TitleStatistic'];
    displayMenu($pagetitel); 
    dispEloChangeWarning();
    genELOListing(); 
    dispfootNote();
    echo "</center>\n";
    echo "</body></html>\n";
}

inviteHandle();

dispEloPage();

?>

